/*
*			toblas.h
*
*	Copyright 1999 by The University at Stony Brook, All rights reserved.
*
*/
#if !defined(_TOBLAS_H)
#define _TOBLAS_H

#ifdef __cplusplus
extern "C" {
#endif

IMPORT	double	dinner_product(int,double*,double*);
IMPORT	double	dnorm_vector(int,double*);
IMPORT	float	inner_product(int,float*,float*);
IMPORT	float	norm_vector(int,float*);
IMPORT	void	add_fvector_times_dvector_to_dvector(int,float*,double*,double*);
IMPORT	void	add_scalar_times_vector_to_vector(int,float,float*,float*);
IMPORT	void	add_scalar_to_vector(int,float,float*);
IMPORT	void	add_vector_times_vector_to_vector(int,float*,float*,float*);
IMPORT	void	copy_dvector_to_fvector(int,double*,float*);
IMPORT	void	copy_fvector_to_dvector(int,float*,double*);
IMPORT	void	copy_vector_to_vector(int,float*,float*);
IMPORT	void	dadd_scalar_times_vector_to_vector(int,double,double*,double*);
IMPORT	void	dadd_scalar_to_vector(int,double,double*);
IMPORT	void	dadd_vector_times_vector_to_vector(int,double*,double*,double*);
IMPORT	void	dcopy_vector_to_vector(int,double*,double*);
IMPORT	void	ddivide_vector_by_vector(int,double*,double*);
IMPORT	void	divide_dvector_by_fvector(int,double*,float*);
IMPORT	void	divide_vector_by_vector(int,float*,float*);
IMPORT	void	dmin_max_vector(int,double*,double*,double*);
IMPORT	void	dmultiply_vector_by_scalar(int,double*,double);
IMPORT	void	dmultiply_vector_by_vector(int,double*,double*);
IMPORT	void	dsubtract_vector_from_vector(int,double*,double*);
IMPORT	void	dsum_elements_of_vector(int,double*,double*);
IMPORT	void	dvector_equals_scalar(int,double*,double);
IMPORT	void	dvector_equals_scalar_plus_vector(int,double*,double,double*);
IMPORT	void	dvector_equals_scalar_times_vector(int,double*,double,double*);
IMPORT	void	dvector_equals_vector_minus_vector(int,double*,double*,double*);
IMPORT	void	dvector_equals_vector_plus_scalar_times_vector(int,double*,double*,double,double*);
IMPORT	void	dzero_vector(int,double*);
IMPORT	void	izero_vector(int,int*);
IMPORT	void	min_max_vector(int,float*,float*,float*);
IMPORT	void	multiply_dvector_by_fvector(int,double*,float*);
IMPORT	void	multiply_vector_by_scalar(int,float*,float);
IMPORT	void	multiply_vector_by_vector(int,float*,float*);
IMPORT	void	subtract_vector_from_vector(int,float*,float*);
IMPORT	void	sum_elements_of_vector(int,float*,float*);
IMPORT	void	vector_equals_scalar(int,float*,float);
IMPORT	void	vector_equals_scalar_plus_vector(int,float*,float,float*);
IMPORT	void	vector_equals_scalar_times_vector(int,float*,float,float*);
IMPORT	void	vector_equals_vector_minus_vector(int,float*,float*,float*);
IMPORT	void	vector_equals_vector_plus_scalar_times_vector(int,float*,float*,float,float*);
IMPORT	void	zero_vector(int,float*);
#if defined(TEST_BLAS)
IMPORT	float	c_inner_product(int,float*,float*);
IMPORT	float	c_norm_vector(int,float*);
IMPORT	void	c_add_scalar_times_vector_to_vector(int,float,float*,float*);
IMPORT	void	c_add_scalar_to_vector(int,float,float*);
IMPORT	void	c_add_vector_times_vector_to_vector(int,float*,float*,float*);
IMPORT	void	c_copy_vector_to_vector(int,float*,float*);
IMPORT	void	c_divide_vector_by_vector(int,float*,float*);
IMPORT	void	c_multiply_vector_by_scalar(int,float*,float);
IMPORT	void	c_multiply_vector_by_vector(int,float*,float*);
IMPORT	void	c_subtract_vector_from_vector(int,float*,float*);
IMPORT	void	c_sum_elements_of_vector(int,float*,float*);
IMPORT	void	c_vector_equals_scalar(int,float*,float);
IMPORT	void	c_vector_equals_scalar_plus_vector(int,float*,float,float*);
IMPORT	void	c_vector_equals_scalar_times_vector(int,float*,float,float*);
IMPORT	void	c_vector_equals_vector_minus_vector(int,float*,float*,float*);
IMPORT	void	c_vector_equals_vector_plus_scalar_times_vector(int,float*,float*,float,float*);
IMPORT	void	c_zero_vector(register int,register float*);
#endif /* defined(TEST_BLAS) */
#ifdef __cplusplus
}
#endif
#endif /* !defined(_TOBLAS_H) */
